'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = init;

var _errorHandler = require('../error-handler');

var _errorHandler2 = _interopRequireDefault(_errorHandler);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _stripe = require('stripe');

var _stripe2 = _interopRequireDefault(_stripe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var debug = (0, _debug2.default)('feathers-stripe:card');

var Service = function () {
  function Service() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, Service);

    if (!options.secretKey) {
      throw new Error('Stripe `secretKey` needs to be provided');
    }

    this.stripe = (0, _stripe2.default)(options.secretKey);
    this.paginate = options.paginate = {};
  }

  _createClass(Service, [{
    key: 'find',
    value: function find(params) {
      // TODO (EK): Handle pagination
      // TODO handle any special query params
      return this.stripe.cards.list(params).catch(_errorHandler2.default);
    }
  }, {
    key: 'get',
    value: function get(id) {
      return this.stripe.cards.retrieve(id).catch(_errorHandler2.default);
    }
  }, {
    key: 'create',
    value: function create(data) {
      return this.stripe.cards.create(data).catch(_errorHandler2.default);
    }
  }, {
    key: 'patch',
    value: function patch() {
      return this.update.apply(this, arguments);
    }
  }, {
    key: 'update',
    value: function update(id, data) {
      return this.stripe.cards.update(id, data).catch(_errorHandler2.default);
    }
  }, {
    key: 'remove',
    value: function remove(id) {
      return this.stripe.cards.del(id).catch(_errorHandler2.default);
    }
  }]);

  return Service;
}();

function init(options) {
  debug('Initializing feathers-stripe:card plugin');

  return new Service(options);
}

init.Service = Service;
module.exports = exports['default'];